/**
Copyright (C) 2013 INRA-URGI
This file is part of TEDNA, a short reads transposable elements assembler
TEDNA is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
GNU Affero General Public License for more details.
See the GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program.
**/
#ifndef KMER_ITERATOR_HPP
#define KMER_ITERATOR_HPP 1

#include <iostream>
#include <string>
#include "globals.hpp"
#include "kmer.hpp"
using namespace std;


class KmerIterator {

	private:
		string         _string;
		unsigned short _size;
		unsigned int   _i;
		string         _currentWord;
		Kmer           _currentKmer;

	public:
		KmerIterator (const string &s, const short size = Globals::KMER);

		bool isOver() const;
		void getNext();
		Kmer operator*() const;
};

#endif
